<template>
  <v-container>
    <v-row justify="center">
      <v-col sm="12" md="8" lg="5">
        <v-card outlined>
          <v-card-text v-if="!sentMsg">
            <v-row justify="center">
              <v-col class="text-center">
                <p class="headline">Recover Your Password</p>
                <span
                  >Enter the email address associated with your account, and
                  we’ll email you a link to make a new password.</span
                >
              </v-col>
            </v-row>
            <v-form ref="form" v-model="valid" lazy-validation>
              <v-row justify="center">
                <v-col xs="12" sm="12" md="12">
                  <v-text-field
                    v-model="email"
                    name="email"
                    label="Enter email"
                    :rules="emailRules"
                    hide-details
                    outlined
                  />
                </v-col>

                <v-col v-if="authErrorMessages" cols="12" xs="12" md="12">
                  <p style="color: red">{{ authErrorMessages }}</p>
                </v-col>
                <v-col xs="12" md="12">
                  <v-btn :loading="loading" outlined block large @click="resetPassword"
                    >Send reset link</v-btn
                  >
                </v-col>
                <v-col xs="12" md="12">
                  <p class="body-1">
                    <router-link to="/login">Go back to login</router-link>
                  </p>
                </v-col>
              </v-row>
            </v-form>
          </v-card-text>
          <v-card-text v-if="sentMsg">
            <v-row justify="center">
              <v-col class="text-center">
                <p>{{sentMsg}}</p>
              </v-col>
            </v-row>
          </v-card-text>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import { mapState, mapGetters } from 'vuex'

export default {
  data: () => ({
    email: '',
    valid: false,
    emailRules: [
      v => !!v || 'E-mail is required',
      v => /.+@.+/.test(v) || 'E-mail must be valid'
    ],
    loading: false,
    sentMsg: null
  }),
  computed: {
    ...mapState('authentication', ['user', 'authErrorMessages']),
    ...mapGetters('authentication', ['isUserLoggedIn'])
  },
  mounted() {
    if (this.isUserLoggedIn) {
      this.$router.push('/dashboard')
    }
  },
  beforeDestroy() {
    this.$store.dispatch('authentication/clearAuthErrors')
    this.sentMsg = null
  },
  methods: {
    resetPassword() {
      if (this.$refs.form.validate()) {
        this.loading = true
        this.$store.dispatch('authentication/forgetPassword', this.email).then(res => {
          this.loading = false
          this.sentMsg = res.msg
        })
      }
    }
  }
}
</script>

<style lang="scss" scoped>
@import '@/sass/variables.scss';

.page-wrapper {
  display: flex;
  justify-content: center;
  flex-direction: column;
  align-items: center;

  .login-page-title {
    text-align: center;
  }

  .login-btn {
    margin-top: 20px;
    cursor: pointer;
    padding: 5px 20px;
    border: 1px solid;
    display: inline-block;
    border-radius: 3px;
    border-color: #2c3e50;

    &:hover {
      color: $vue-color;
      border-color: $vue-color;
    }
  }
  .text-or {
    font-size: 18px;
    color: grey;
  }
}
</style>
